

package draw;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
public class MiCanvas extends Canvas {
    private int tipo=Figura.LINEA;
    private Vector figuras=new Vector();
    private Figura figActual;
    private Graphics gc;
    private Point ini, fin;
    public MiCanvas(int tipo) {
        setBackground(Color.white);
        this.tipo=tipo;
        addMouseListener(new RatonPoner());
        addMouseMotionListener(new RatonMover());
        figActual=new Figura();
    }
    public void setFigura(int tipo){
        this.tipo=tipo;
        figActual=new Figura(tipo);
    }
    public void borrar(){
        figuras.removeAllElements();
        repaint();
    }
    private void empiezaDibujar(Point p){
        ini=p;
        fin=p;
        gc=getGraphics();
        gc.setXORMode(getBackground());
        figActual.dibujar(gc, ini, fin);
    }
    private void dibuja(Point p){
        figActual.dibujar(gc, ini, fin);
        fin=p;
        figActual.dibujar(gc, ini, fin);
    }
    private void terminaDibujar(){
        figActual.dibujar(gc, ini, fin);
        gc.setPaintMode();
        figActual.dibujar(gc, ini, fin);
        gc.dispose();
    }

    public void paint(Graphics g){
        for(int i=0; i<figuras.size(); i++){
            Figura fig=(Figura)figuras.elementAt(i);
            fig.dibujar(g);
        }
    }
 class RatonPoner extends MouseAdapter{
    public void mousePressed(MouseEvent ev){
        empiezaDibujar(ev.getPoint());
    }
    public void mouseReleased(MouseEvent ev){
        terminaDibujar();
        figuras.addElement(figActual);
    }
 }
 class RatonMover extends MouseMotionAdapter{
    public void mouseDragged(MouseEvent ev){
        dibuja(ev.getPoint());
    }
 }


}