

package draw1;
import java.awt.*;

public abstract class Figura {
    protected Point ini, fin;
    public Figura(Point ini, Point fin) {
        this.ini=ini;
        this.fin=fin;
    }
    public Figura(){
        this(new Point(), new Point());
    }
    protected void actualizar(Point ini, Point fin){
        this.ini=ini;
        this.fin=fin;
    }

//mientras se dibuja la figura
    public abstract void dibujar(Graphics g, Point ini, Point fin);

 //figura final
    public void dibujar(Graphics g){
        dibujar(g, ini, fin);
    }
}

class Linea extends Figura{
    public Linea(Point ini, Point fin) {
        super(ini, fin);
   }
    public Linea(){
        this(new Point(), new Point());
    }
    public void dibujar(Graphics g, Point ini, Point fin){
        actualizar(ini, fin);
        g.drawLine(ini.x, ini.y, fin.x, fin.y);
    }
}


class Rectangulo extends Figura{
    public Rectangulo(Point ini, Point fin) {
        super(ini, fin);
   }
    public Rectangulo(){
        this(new Point(), new Point());
    }
    public void dibujar(Graphics g, Point ini, Point fin){
        actualizar(ini, fin);
        int ancho=Math.abs(ini.x-fin.x);
        int alto=Math.abs(ini.x-fin.x);
        int iniX=Math.min(ini.x, fin.x);
        int iniY=Math.min(ini.y, fin.y);
        g.drawRect(iniX, iniY, ancho, alto);
    }
}

class Elipse extends Figura{
    public Elipse(Point ini, Point fin) {
        super(ini, fin);
   }
    public Elipse(){
        this(new Point(), new Point());
    }
    public void dibujar(Graphics g, Point ini, Point fin){
        actualizar(ini, fin);
        int ancho=Math.abs(ini.x-fin.x);
        int alto=Math.abs(ini.x-fin.x);
        int iniX=Math.min(ini.x, fin.x);
        int iniY=Math.min(ini.y, fin.y);
        g.drawOval(iniX, iniY, ancho, alto);
    }
}

