package anima4;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class AnimaApplet4 extends Applet implements Runnable {
    Image[] numeros = new Image[10];
    Thread  anima;
    MediaTracker  tracker;
    int retardo = 800;
    int indice = 0;
//doble buffer
    Image imag;
    Graphics gBuffer;

  public void init() {
// carga las imgenes
    tracker = new MediaTracker(this);
    for (int i = 0; i < 10; i++) {
        numeros[i] = getImage(getDocumentBase(), "contadorGif/" + i + ".gif");
        tracker.addImage(numeros[i], 0);
    }
  }

  public void start() {
    if (anima == null) {
        anima = new Thread(this);
        anima.start();
    }
  }

  public void stop() {
    if (anima != null) {
        anima.stop();
        anima = null;
    }
  }

  public void run() {
//han de estar completamente cargadas las imgnes antes de empezar a correr la animacin
    try {
        tracker.waitForID(0);
    }catch (InterruptedException ex) {
        return;
    }
// corre la animacin
    long t = System.currentTimeMillis();
    while (true) {
       if (++indice>=numeros.length){
            indice = 0;
        }
        repaint();

 /*		synchronized (this) {
 		    indice++;
 		    if (indice >=numeros.length) {
 			    indice=0;
 		    }
 		}
       repaint();
   */
        try {
            t+=retardo;
            Thread.sleep(Math.max(0, t - System.currentTimeMillis()));
        }catch(InterruptedException e) {
            break;
        }
    }
  }

  public void update(Graphics g) {
    int ancho=getSize().width;
    int alto=getSize().height;
    if (gBuffer == null) {
        imag = createImage(ancho, alto);
        gBuffer = imag.getGraphics();
    }

    gBuffer.setColor(getBackground());
    gBuffer.fillRect(0, 0, ancho, alto);
    gBuffer.setColor(Color.black);
// muestra las imgenes
    gBuffer.drawImage(numeros[indice], 0, 0, this);
// Transfiere la imagen off a al contexto grfico del applet
    g.drawImage(imag, 0, 0, null);
  }

  public void paint(Graphics g) {
    Font font = new Font("TimesRoman", Font.BOLD, 16);
    g.setFont(font);
    FontMetrics fm = g.getFontMetrics(font);
    String texto;
    if ((tracker.statusID(0, true) == MediaTracker.LOADING)) {
//se estn cargando las imgenes
      texto="Cargando las imgenes ....";
      g.drawString(texto, (getSize().width - fm.stringWidth(texto)) / 2, ((getSize().height - fm.getHeight()) / 2) + fm.getAscent());
    }
  }
}

