

package dielectrico;

import java.util.*;
public class Dielectrico {
    private double po;         //momento dipolar
    public int nParticulas;
//nmeros aleatorios
    private Random rnd=new Random();
    private static final double COEFICIENTE=0.7246; 

    public Dielectrico(int nParticulas, double momento) {
        this.nParticulas=nParticulas;
        po=momento;
    }
//devuelve el coseno del ngulo 0-PI
    private double sorteo(double campo, double temperatura){
        double aleatorio=rnd.nextDouble();
        double u=COEFICIENTE*po*campo/temperatura;
        double coseno=Math.log((1-aleatorio)*Math.exp(u)+aleatorio*Math.exp(-u))/u;
        return coseno;
    }
//el campo elctrico viene dado en unidades 10 elevado a 7 N/C
    public double momentoDipolarMedio(double campo, double temperatura){
        if(temperatura<=0.0){
            return po;
        }
        double media=0.0;
        for(int i=0; i<nParticulas; i++){
            media+=sorteo(campo, temperatura);
        }
        return (media*po)/nParticulas;
    }
}

