package niveles;
import java.util.*;

public class Niveles {
    private static final double COEFICIENTE=11594.2;   //ev/k= 1.6 exp-19/1.38 exp-23
    private int nNiveles;       //nmero de niveles
    private double[] energia;   //energa de cada nivel
    public int nParticulas;    //nmero de partculas del sistema
    public int[] n;            //nmero de partculas en cada nivel
    private double[] p;         //distribucin de probabilidades de ocupacin
//nmeros aleatorios
    private Random rnd=new Random();

    public Niveles(int nParticulas, double[] energia) {
        this.nParticulas=nParticulas;
        this.energia=energia;
        nNiveles=energia.length;
        n=new int[nNiveles];
        p=new double[nNiveles];
    }
    private void probabilidades(double T){
        for(int i=0; i<nNiveles; i++){
            p[i]=Math.exp(-energia[i]*COEFICIENTE/T);
            n[i]=0;
        }
//acumulada
        for(int i=1; i<nNiveles; i++){
            p[i]+=p[i-1];
        }
//normalizar
        for(int i=0; i<nNiveles; i++){
            p[i]/=p[nNiveles-1];
        }
    }

    public void distribucion(double temperatura){
        double aleatorio;
        probabilidades(temperatura);
        for(int i=0; i<nParticulas; i++){
            aleatorio=rnd.nextDouble();
            for(int j=0; j<nNiveles; j++){
                if(aleatorio<p[j]){
                    n[j]++;
                    break;
                }
            }
        }
    }
    public void mostrarOcupacion(double temperatura){
        distribucion(temperatura);
        System.out.println("nivel \t ocupacin ");
        for(int i=0; i<nNiveles; i++){
            System.out.println(" "+i+" \t "+n[i]);
        }
    }

}