package armonico1;

import java.awt.*;

public class MiCanvas extends Canvas {
//anchura y altura del canvas
     int wAncho, wAlto;
//anchura y altura de un carcter
     int cAlto, cAncho;
//orgenes
     int orgX, orgY;
//escala
     double escalaY, escalaX;
//estado
    int n=0;
    Polygon pol=new Polygon();

  public MiCanvas() {
    setBackground(Color.white);
  }
  void origenEscalas(Graphics g){
     wAncho=getSize().width;
     wAlto=getSize().height;
//dimensiones de los caracteres
     cAlto=g.getFontMetrics().getHeight();
     cAncho=g.getFontMetrics().stringWidth("0");
//escalas
     escalaY=(double)(wAlto-3*cAlto)/7.0;
     escalaX=(double)(wAncho-cAlto)/7.0;
//orgenes
     orgX=wAncho/2;
     orgY=wAlto-2*cAlto;
 }
 void setNuevo(int nEstado){
    this.n=nEstado;
    repaint();
 }
 //calcula la funcin de onda
 double funcion(double x){
        double y=(1.0/Math.sqrt(potencia2(n)*Math.sqrt(Math.PI)*factorial(n)))*hermite(x, n)*Math.exp(-x*x/2);
        return y;
 }

 //funcin recursiva polinomio de Hermite
 private double hermite(double x, int n){
        if(n==0) return 1.0;
        if(n==1) return 2*x;
        return (2*x*hermite(x, n-1)-2*(n-1)*hermite(x, n-2));
 }
 private long potencia2(int n){
        long result=1;
        for(int i=1; i<=n; i++){
            result*=2;
        }
        return result;
 }
 private long factorial(int n){
        if(n==0) return 1;
        long result=1;
        for(int i=1; i<=n; i++){
            result*=i;
        }
        return result;
 }

 void graficaPotencial(Graphics g){
    g.setColor(Color.black);
    String texto;
    int x1, y1;
//escala
    g.drawLine(0, orgY, wAncho, orgY);
    g.drawString("x", wAncho-2*cAncho, orgY-2);
    for(int i=-4; i<=4; i++){
        x1=orgX+(int)(escalaX*i);
        g.drawLine(x1, orgY, x1, orgY+cAncho);
        texto=String.valueOf(i);
        g.drawString(texto, x1-g.getFontMetrics().stringWidth(texto)/2, orgY+cAncho+cAlto);
        if(i==4) break;
        for(int j=1; j<5; j++){
            x1=orgX+(int)(escalaX*(i+(double)j/5));
            g.drawLine(x1, orgY, x1, orgY+cAncho/2);
        }
    }
    g.drawLine(orgX, orgY, orgX, 0);
    g.drawString("Energa", orgX+cAncho, cAlto);
    for(int i=0; i<=7; i++){
        y1=orgY-(int)(escalaY*i);
        g.drawLine(orgX, y1, orgX-cAncho, y1);
        texto=String.valueOf(i);
        g.drawString(texto, orgX-4*cAncho, y1+cAlto/2);
    }
//energa potencial
    pol.npoints=0;
    double x=0.0;
    do{
        x1=orgX+(int)(x*escalaX);
        y1=orgY-(int)(x*x*escalaY/2);
        pol.addPoint(x1, y1);
        x+=0.05;
    }while(y1>0);
    pol.addPoint(wAncho, 0);
    pol.addPoint(wAncho, orgY);
    g.setColor(Color.gray);
    g.fillPolygon(pol);
    for(int i=0; i<pol.npoints; i++){
        pol.xpoints[i]=wAncho-pol.xpoints[i];
    }
    g.fillPolygon(pol);

 }
 void funcionOnda(Graphics g){
    g.setColor(Color.blue);
    int y1=orgY-(int)((n+0.5)*escalaY);
    g.drawLine(0, y1, wAncho, y1);
    int x1=orgX;
    y1=orgY;
    int x3=orgX;
    int y3=orgY;
    int x2, y2, x4, y4;
    g.setColor(Color.red);
    double x=0.0, y;
    int signo=(n%2==0)?1:-1;
    do{
        x2=orgX+(int)(x*escalaX);
        y=funcion(x);
        y2=orgY-(int)((n+0.5+y)*escalaY);
        g.drawLine(x1, y1, x2, y2);
        x1=x2; y1=y2;
        x4=orgX-(int)(x*escalaX);
        y4=orgY-(int)((n+0.5+signo*y)*escalaY);
        g.drawLine(x3, y3, x4, y4);
        x3=x4; y3=y4;
        x+=0.05;
    }while(x2<wAncho);


 }


 public void paint(Graphics g){
     origenEscalas(g);
     graficaPotencial(g);
     funcionOnda(g);
   }


}
