package draw1;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class MiCanvas extends Canvas implements MouseListener, MouseMotionListener{
    private Vector figuras=new Vector();
    private Figura figActual;
    private Graphics gc;
    private Point ini, fin;
    public MiCanvas() {
        setBackground(Color.white);
        figActual=new Linea();
        addMouseListener(this);
        addMouseMotionListener(this);
    }
    public void setFigura(int tipo){
        switch(tipo){
            case 0:
                figActual=new Linea();
                break;
            case 1:
                figActual=new Rectangulo();
                break;
            case 2:
                figActual=new Elipse();
                break;
            default:
                figActual=new Linea();
                break;
        }
    }
    public void borrar(){
        figuras.removeAllElements();
        repaint();
    }
    void empiezaDibujar(Point p){
        ini=p;
        fin=p;
        gc=getGraphics();
        gc.setXORMode(getBackground());
        figActual.dibujar(gc, ini, fin);
    }
    void dibuja(Point p){
        figActual.dibujar(gc, ini, fin);
        fin=p;
        figActual.dibujar(gc, ini, fin);
    }
    void terminaDibujar(){
        figActual.dibujar(gc, ini, fin);
        gc.setPaintMode();
        figActual.dibujar(gc, ini, fin);
        gc.dispose();
    }

    public void paint(Graphics g){
        for(int i=0; i<figuras.size(); i++){
            Figura fig=(Figura)figuras.elementAt(i);
            fig.dibujar(g);
        }
    }
//implementacin de las funciones del interface MouseListener
    public void mousePressed(MouseEvent ev){
        empiezaDibujar(ev.getPoint());
    }
    public void mouseReleased(MouseEvent ev){
        terminaDibujar();
        figuras.addElement(figActual);
    }
    public void mouseClicked(MouseEvent ev){}

 //implementacin de las funciones del interface MouseMotionListener
   public void mouseDragged(MouseEvent ev){
        dibuja(ev.getPoint());
    }
     public void mouseEntered(MouseEvent ev){}
     public void mouseExited(MouseEvent ev){}
     public void mouseMoved(MouseEvent ev){}

}