
package ecuacion3;

public abstract class Ecuacion {
    protected static final double CERO=1e-10;
     protected static final double ERROR=0.0001;
     protected final int MAXITER=100;
     protected final int MAXRAICES=20;
     protected double raices[]=new double[MAXRAICES];
     protected int iRaiz=0;

    protected double puntoMedio(double a, double b)throws RaizExcepcion{
        double m, ym;
        int iter=0;
        do{
            m=(a+b)/2;
            ym=f(m);
            if(Math.abs(ym)<CERO)           break;
            if(Math.abs((a-b)/m)<ERROR)     break;

            if((f(a)*ym)<0)     b=m;
            else                a=m;
            iter++;
        }while(iter<MAXITER);
        if(iter==MAXITER){
            throw new RaizExcepcion("No se ha encontrado una raz");
        }
        return m;
    }

    protected void explorar(double xIni, double xFin, double dx){
        double y1, y2;
	    iRaiz=0;
        y1=f(xIni);
        for(double x=xIni; x<xFin; x+=dx){
            y2=f(x+dx);
//Uno de los extremos del intervalo es raz
            if(Math.abs(y1)<CERO && iRaiz<MAXRAICES){
                raices[iRaiz++]=x;
                y1=y2;
                continue;
            }
//no hay raz en este intervalo
            if(y1*y2>=0.0){
                y1=y2;
                continue;
            }
//hay una raz en este intervalo
            if(iRaiz<MAXRAICES){
                try{
                    raices[iRaiz]=puntoMedio(x, x+dx);
                    iRaiz++;
                }catch(RaizExcepcion ex){
                    System.out.println(ex.getMessage());
                }
            }
            y1=y2;
        }
    }
    public double[] hallarRaices(double ini, double fin, double paso){
        explorar(ini, fin, paso);
        double solucion[]=new double[iRaiz];
        for(int i=0; i<iRaiz; i++){
            solucion[i]=(double)Math.round(raices[i]*1000)/1000;
        }
        return solucion;
    }

    abstract public double f(double x);
}

class RaizExcepcion extends Exception {
  public RaizExcepcion(String s) {
         super(s);
  }
}
