package paramagnetico;

import java.util.*;
public class Paramagnetico {
    private int mu;         //momento magntico en unidades de Bohr
    private double[] p;  //distribucin de probabilidades de ocupacin
    public int nParticulas;
//nmeros aleatorios
    private Random rnd=new Random();
    private static final double COEFICIENTE=9.2732e-24/1.3805e-23;     //Magnetn de Bohr/cte de Boltzmann

    public Paramagnetico(int nParticulas, int momento) {
        this.nParticulas=nParticulas;
        mu=momento;
        p=new double[mu+1];
    }

    private void probabilidades(double campo, double temperatura){
        for(int i=0; i<=mu; i++){
            p[i]=Math.exp(COEFICIENTE*(2*i-mu)*campo/temperatura);
        }
//acumulada
        for(int i=1; i<=mu; i++){
            p[i]+=p[i-1];
        }
//normalizar
        for(int i=0; i<=mu; i++){
            p[i]/=p[mu];
        }
    }
    private int sorteo(){
        double aleatorio=rnd.nextDouble();
        int i=0;
        for(i=0; i<=mu; i++){
            if(aleatorio<p[i]){
                break;
            }
        }
        return (2*i-mu);    //momento magntico
    }

    public double momentoMagneticoMedio(double campo, double temperatura){
        if(temperatura<=0.0){
            return mu;
        }
        probabilidades(campo, temperatura);
        int media=0;
        for(int i=0; i<nParticulas; i++){
            media+=sorteo();
        }
        return (double)media/nParticulas;
    }

}

