package procesos;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class ProcesosApplet extends Applet {
    private static final int MAX_CIRCULOS=10;
    private Circulo[] circulos= new Circulo[MAX_CIRCULOS];
    private static final Color[] colores={new Color(255,0,0), new Color(0, 255,0), new Color(0, 0, 255),
          new Color(0, 255, 255), new Color(255, 0, 255), new Color(255, 255, 0),
          new Color(128, 0, 0), new Color(255, 128, 0), new Color(0, 64, 64),
          new Color(128, 128, 255), new Color(128, 0, 64), new Color(255, 0, 128),
          new Color(192, 192, 192), new Color(128, 128, 0)};
    int anchoApplet;
    int altoApplet;
//Doble buffer
     Image imag;
     Graphics gBuffer;

  public void init() {
    try {
    jbInit();
    }
    catch (Exception e) {
    e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    setBackground(Color.white);
    anchoApplet=getSize().width;
    altoApplet=getSize().height;
    for(int i=0; i<MAX_CIRCULOS; i++){
        int radio=5+(int)(Math.random()*20);
        Color color=colores[(int)(colores.length*Math.random())];
        int tiempo=50+(int)(500*Math.random());
        int x=20+(int)((anchoApplet-40)*Math.random());
        int y=20+(int)((altoApplet-40)*Math.random());
        circulos[i]=new Circulo(this, color, radio, tiempo, x, y);
    }
  }
  public void start(){
    for(int i=0; i<MAX_CIRCULOS; i++){
        circulos[i].start();
    }
  }

  public void stop(){
    for(int i=0; i<MAX_CIRCULOS; i++){
        circulos[i].stop();
    }
  }
  public void update(Graphics g){
    if(gBuffer==null){
        imag=createImage(anchoApplet, altoApplet);
        gBuffer=imag.getGraphics();
    }
    gBuffer.setColor(getBackground());
    gBuffer.fillRect(0,0, anchoApplet, altoApplet);
//dibuja los circulos
    for(int i=0; i<MAX_CIRCULOS; i++){
        circulos[i].dibujaCirculo(gBuffer);
    }
//transfiere la imagen al contexto grfico del canvas
    g.drawImage(imag, 0, 0, null);
 }
}

 